/*----- PROTECTED REGION ID(KeithleyMultimeters.cpp) ENABLED START -----*/
static const char *RcsId = "$Id:  $";
//=============================================================================
//
// file :        KeithleyMultimeters.cpp
//
// description : C++ source for the KeithleyMultimeters class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               KeithleyMultimeters are implemented in this file.
//
// project :     Keithley multimeters device
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


// #include "KeithleyMultimeters.h"
#include "KeithleyMultimetersClass.h"
#include <PogoHelper.h>
#include <yat4tango/InnerAppender.h>
#include <yat4tango/YatLogAdapter.h>
#include <yat4tango/DeviceInfo.h>
#include <yat4tango/PropertyHelper.h>

static const std::size_t MIN_LENGTH = 2;        //- min Keithley buffer size
static const std::size_t MAX_LENGTH = 450000;   //- max Keithley buffer size
static const std::size_t MAX_STRING_LENGTH = 64;//- attr string size
static const double MIN_NPLC_VAL    = 0.002;
static const double MAX_NPLC_VAL    = 50.;

/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters.cpp

/**
 *  KeithleyMultimeters class description:
 *    Device to interface a Keithley multimeters 2701. <br>
 *    The Keithley is configured in Voltmeter <br>
 *    The ReadBufferedData command initiate a scan and <br>
 *    readback data stored in the Keithley buffer up to 450000 points. <br>
 *    nbPoins and nPLC attributes are INVALID in RUNNING state (while Keithley integrates).
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name      |  Method name
//================================================================
//  State             |  dev_state
//  Status            |  Inherited (no method)
//  ReadBufferedData  |  read_buffered_data
//  WriteRead         |  write_read
//  Abort             |  abort
//  Configure         |  configure
//  StartAcquisition  |  start_acquisition
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  nPLC                |  Tango::DevDouble	Scalar
//  triggerSource       |  Tango::DevString	Scalar
//  nbPoints            |  Tango::DevULong	Scalar
//  nbBufferizedPoints  |  Tango::DevULong	Scalar
//  data                |  Tango::DevDouble	Spectrum  ( max = 450000)
//================================================================

namespace KeithleyMultimeters_ns
{
/*----- PROTECTED REGION ID(KeithleyMultimeters::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimeters::KeithleyMultimeters()
 *	Description : Constructors for a Tango device
 *                implementing the classKeithleyMultimeters
 */
//--------------------------------------------------------
KeithleyMultimeters::KeithleyMultimeters(Tango::DeviceClass *cl, string &s)
 : Tango::Device_4Impl(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(KeithleyMultimeters::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::constructor_1
}
//--------------------------------------------------------
KeithleyMultimeters::KeithleyMultimeters(Tango::DeviceClass *cl, const char *s)
 : Tango::Device_4Impl(cl, s)
{
	/*----- PROTECTED REGION ID(KeithleyMultimeters::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::constructor_2
}
//--------------------------------------------------------
KeithleyMultimeters::KeithleyMultimeters(Tango::DeviceClass *cl, const char *s, const char *d)
 : Tango::Device_4Impl(cl, s, d)
{
	/*----- PROTECTED REGION ID(KeithleyMultimeters::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimeters::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void KeithleyMultimeters::delete_device()
{
	DEBUG_STREAM << "KeithleyMultimeters::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyMultimeters::delete_device) ENABLED START -----*/
	
	//	Delete device allocated objects
	if ( m_kmgr )
	{
		m_kmgr->exit();
		m_kmgr = 0;
	}

  DELETE_SCALAR_ATTRIBUTE(attr_nbPoints_read);
  DELETE_SCALAR_ATTRIBUTE(attr_nbBufferizedPoints_read);
  DELETE_SCALAR_ATTRIBUTE(attr_nPLC_read);
	DELETE_SPECTRUM_ATTRIBUTE(attr_data_read);
  DELETE_DEVSTRING_ATTRIBUTE(attr_triggerSource_read);
  
  yat4tango::YatLogAdapter::release();
  yat4tango::InnerAppender::release(this);
  yat4tango::DeviceInfo::release	 (this);
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::delete_device
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimeters::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void KeithleyMultimeters::init_device()
{
	DEBUG_STREAM << "KeithleyMultimeters::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyMultimeters::init_device_before) ENABLED START -----*/
	
	//	Initialization before get_device_property() call
	m_kmgr = 0;
  m_k_status = "Device initialisation on the way ...";
  m_property_missing = false;

	//- By default the max depth of the log buffer is 512
	yat4tango::YatLogAdapter::initialize(this);
	yat4tango::InnerAppender::initialize(this);
	yat4tango::DeviceInfo::initialize   (this, YAT_XSTR(PROJECT_NAME), YAT_XSTR(PROJECT_VERSION) );

	CREATE_SCALAR_ATTRIBUTE(attr_nbPoints_read);
	CREATE_SCALAR_ATTRIBUTE(attr_nbBufferizedPoints_read);
	CREATE_SCALAR_ATTRIBUTE(attr_nPLC_read);
	CREATE_SPECTRUM_ATTRIBUTE(attr_data_read, MAX_LENGTH, 0.0);
	CREATE_DEVSTRING_ATTRIBUTE(attr_triggerSource_read,MAX_STRING_LENGTH,"EXTernal");

	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::init_device_before
	

	//	Get the device properties from database
	get_device_property();
	

	/*----- PROTECTED REGION ID(KeithleyMultimeters::init_device) ENABLED START -----*/
	
	//	Initialize device
	try
	{
			//- create Manager
		if ( !m_property_missing && !communicationLinkName.empty() )
		{
				m_kmgr = new KeithleyManager(communicationLinkName, specificConfiguration, this);
		}

		//- start Manager thread
		if ( m_kmgr )
		{
			m_kmgr->go();
			m_k_status = "Device initialisation done.";
		}
	}
	catch(std::bad_alloc& bd)
	{
		m_k_status = "Device initialisation failed : not enough memory.";
		FATAL_STREAM << "KeithleyMultimeters::init_device() -> caught std::BadAlloc !" << std::endl;
		FATAL_STREAM << bd.what() << std::endl;
	}
	catch(Tango::DevFailed& df)
	{
		m_k_status = "Device initialisation failed : caught a DevFailed error, see logs.";
		FATAL_STREAM << "KeithleyMultimeters::init_device() -> caught DevFailed !" << std::endl;
		FATAL_STREAM << df << std::endl;
	}
	catch(...)
	{
		m_k_status = "Device initialisation failed : caught a generic error.";
		FATAL_STREAM << "KeithleyMultimeters::init_device() -> caught [...] !" << std::endl;
	}

	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::init_device
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimeters::get_device_property()
 *	Description : Read database to initialize property data members.
 */
//--------------------------------------------------------
void KeithleyMultimeters::get_device_property()
{
	/*----- PROTECTED REGION ID(KeithleyMultimeters::get_device_property_before) ENABLED START -----*/
	
	//	Initialize property data members
	communicationLinkName.clear();
	specificConfiguration.clear();
	specificConfiguration.push_back("#Lines begining with # are comments");
	//- configure Keithley in Voltmeter
	specificConfiguration.push_back("#configure Keithley in Voltmeter");
	specificConfiguration.push_back("FUNC 'VOLT'");
	//- external trigger source
	specificConfiguration.push_back("#external trigger source");
	std::string trigSrc = std::string("TRIG:SOUR ") + std::string(*attr_triggerSource_read);
	specificConfiguration.push_back(trigSrc);
	//- read values only (no timestamp...)
	specificConfiguration.push_back("#read values only (no timestamp...)");
	specificConfiguration.push_back("FORM:ELEM READ");

	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::get_device_property_before


	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("CommunicationLinkName"));
	dev_prop.push_back(Tango::DbDatum("SpecificConfiguration"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);
	
		//	get instance on KeithleyMultimetersClass to get class property
		Tango::DbDatum	def_prop, cl_prop;
		KeithleyMultimetersClass	*ds_class =
			(static_cast<KeithleyMultimetersClass *>(get_device_class()));
		int	i = -1;

		//	Try to initialize CommunicationLinkName from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  communicationLinkName;
		else {
			//	Try to initialize CommunicationLinkName from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  communicationLinkName;
		}
		//	And try to extract CommunicationLinkName value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  communicationLinkName;

		//	Try to initialize SpecificConfiguration from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  specificConfiguration;
		else {
			//	Try to initialize SpecificConfiguration from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  specificConfiguration;
		}
		//	And try to extract SpecificConfiguration value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  specificConfiguration;

	}

	/*----- PROTECTED REGION ID(KeithleyMultimeters::get_device_property_after) ENABLED START -----*/
	
	//	Check device property data members init
	if ( communicationLinkName.empty())
  {
    m_property_missing = true;
  }

  //- TODO : generation auto
	yat4tango::PropertyHelper::create_property_if_empty(this, dev_prop,"[name of the device which handles the communication protocol]","CommunicationLinkName");
	yat4tango::PropertyHelper::create_property_if_empty(this, dev_prop,specificConfiguration,"SpecificConfiguration");

	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::get_device_property_after
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimeters::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void KeithleyMultimeters::always_executed_hook()
{
	// INFO_STREAM << "KeithleyMultimeters::always_executed_hook()  " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyMultimeters::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests
	

	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimeters::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void KeithleyMultimeters::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	// DEBUG_STREAM << "KeithleyMultimeters::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(KeithleyMultimeters::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	// DEBUG_STREAM << "KeithleyMultimeters::read_attr_hardware(vector<long> &attr_list) entering... "<< endl;
	//	Add your own code here
	if ( !m_kmgr )
	{
		Tango::Except::throw_exception(
			"INIT_ERROR",
			"Device is not initialised.",
			"KeithleyMultimeters::read_attr_hardware()");
	}

	std::vector<double> v_data = m_kmgr->get_freshData();

	std::size_t data_size = v_data.size();
	
	for (size_t i=0; i<data_size; i++)
	{
		attr_data_read[i] = v_data.at(i);
	}

	m_total_number_of_samples_in_spectrum = data_size;

	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::read_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute nPLC related method
 *	Description: Integration rate in line cycles in the range [0.002,50]
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void KeithleyMultimeters::read_nPLC(Tango::Attribute &attr)
{
	// DEBUG_STREAM << "KeithleyMultimeters::read_nPLC(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(KeithleyMultimeters::read_nPLC) ENABLED START -----*/
	// DEBUG_STREAM << "KeithleyMultimeters::read_nPLC(Tango::Attribute &attr) entering... "<< endl;

  *attr_nPLC_read = m_kmgr->get_nplc();
  
  attr.set_value(attr_nPLC_read);

	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::read_nPLC
}
//--------------------------------------------------------
/**
 *	Write attribute nPLC related method
 *	Description: Integration rate in line cycles in the range [0.002,50]
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void KeithleyMultimeters::write_nPLC(Tango::WAttribute &attr)
{
	// DEBUG_STREAM << "KeithleyMultimeters::write_nPLC(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(KeithleyMultimeters::write_nPLC) ENABLED START -----*/
	// DEBUG_STREAM << "KeithleyMultimeters::write_nPLC(Tango::WAttribute &attr) entering... "<< endl;
  
  if ( !m_kmgr )
  {
    Tango::Except::throw_exception(
      "INIT_ERROR",
      "Device is not initialised.",
      "KeithleyMultimeters::write_nPLC()");
  }

  //- check value
  if(w_val < MIN_NPLC_VAL || w_val > MAX_NPLC_VAL)
  {
    Tango::Except::throw_exception(
      "OUT_OF_RANGE",
      "nPLC value should be in the range [0.002,50].",
      "KeithleyMultimeters::write_nPLC()");
  }
  
  m_kmgr->set_nplc(w_val);

	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::write_nPLC
}
//--------------------------------------------------------
/**
 *	Read attribute triggerSource related method
 *	Description: Select control source (IMMediate, TIMer, MANual, BUS or EXTernal).
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void KeithleyMultimeters::read_triggerSource(Tango::Attribute &attr)
{
	// DEBUG_STREAM << "KeithleyMultimeters::read_triggerSource(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(KeithleyMultimeters::read_triggerSource) ENABLED START -----*/
	//DEBUG_STREAM << "KeithleyMultimeters::read_triggerSource(Tango::Attribute &attr) entering... "<< endl;

  std::string trigSrc = m_kmgr->get_trigger_source();

  ::strcpy(*attr_triggerSource_read, trigSrc.c_str());
  
  attr.set_value(attr_triggerSource_read);

	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::read_triggerSource
}
//--------------------------------------------------------
/**
 *	Write attribute triggerSource related method
 *	Description: Select control source (IMMediate, TIMer, MANual, BUS or EXTernal).
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void KeithleyMultimeters::write_triggerSource(Tango::WAttribute &attr)
{
	// DEBUG_STREAM << "KeithleyMultimeters::write_triggerSource(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevString	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(KeithleyMultimeters::write_triggerSource) ENABLED START -----*/
  if ( !m_kmgr )
  {
    Tango::Except::throw_exception(
      "INIT_ERROR",
      "Device is not initialised.",
      "KeithleyMultimeters::write_triggerSource()");
  }
	
	m_kmgr->set_trigger_source(w_val);

	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::write_triggerSource
}
//--------------------------------------------------------
/**
 *	Read attribute nbPoints related method
 *	Description: Acquisition number of points
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void KeithleyMultimeters::read_nbPoints(Tango::Attribute &attr)
{
	// DEBUG_STREAM << "KeithleyMultimeters::read_nbPoints(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(KeithleyMultimeters::read_nbPoints) ENABLED START -----*/
	// DEBUG_STREAM << "KeithleyMultimeters::read_nbPoints(Tango::Attribute &attr) entering... "<< endl;

  *attr_nbPoints_read = m_kmgr->get_buffer_size();
  
  attr.set_value(attr_nbPoints_read);

	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::read_nbPoints
}
//--------------------------------------------------------
/**
 *	Write attribute nbPoints related method
 *	Description: Acquisition number of points
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void KeithleyMultimeters::write_nbPoints(Tango::WAttribute &attr)
{
	// DEBUG_STREAM << "KeithleyMultimeters::write_nbPoints(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevULong	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(KeithleyMultimeters::write_nbPoints) ENABLED START -----*/
	// DEBUG_STREAM << "KeithleyMultimeters::write_nbPoints(Tango::WAttribute &attr) entering... "<< endl;
  
  if ( !m_kmgr )
  {
    Tango::Except::throw_exception(
      "INIT_ERROR",
      "Device is not initialised.",
      "KeithleyMultimeters::write_nbPoints()");
  }

  //- check value
  if(w_val < MIN_LENGTH || w_val > MAX_LENGTH)
  {
    Tango::Except::throw_exception(
      "OUT_OF_RANGE",
      "nbPoints value should be in the range [2,450000].",
      "KeithleyMultimeters::write_nbPoints()");
  }
  
  m_kmgr->set_buffer_size(w_val);

	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::write_nbPoints
}
//--------------------------------------------------------
/**
 *	Read attribute nbBufferizedPoints related method
 *	Description: Number of points in the Keithley buffer
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void KeithleyMultimeters::read_nbBufferizedPoints(Tango::Attribute &attr)
{
	// DEBUG_STREAM << "KeithleyMultimeters::read_nbBufferizedPoints(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(KeithleyMultimeters::read_nbBufferizedPoints) ENABLED START -----*/
	// DEBUG_STREAM << "KeithleyMultimeters::read_bufferedPoints(Tango::Attribute &attr) entering... "<< endl;
  *attr_nbBufferizedPoints_read = m_kmgr->get_actual_nbPoints();
  
  attr.set_value(attr_nbBufferizedPoints_read);
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::read_nbBufferizedPoints
}
//--------------------------------------------------------
/**
 *	Read attribute data related method
 *	Description: Keithley bufferised data
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Spectrum max = 450000
 */
//--------------------------------------------------------
void KeithleyMultimeters::read_data(Tango::Attribute &attr)
{
	// DEBUG_STREAM << "KeithleyMultimeters::read_data(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(KeithleyMultimeters::read_data) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_data_read, m_total_number_of_samples_in_spectrum);
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::read_data
}

//--------------------------------------------------------
/**
 *	Method      : KeithleyMultimeters::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void KeithleyMultimeters::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(KeithleyMultimeters::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Command State related method
 *	Description: This command gets the device state (stored in its device_state data member) and returns it to the caller.
 *
 *	@returns Device state
 */
//--------------------------------------------------------
Tango::DevState KeithleyMultimeters::dev_state()
{
	// DEBUG_STREAM << "KeithleyMultimeters::State()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyMultimeters::dev_state) ENABLED START -----*/
	
	Tango::DevState	argout = Tango::UNKNOWN; // replace by your own algorithm
	//	Add your own code
	// DEBUG_STREAM << "KeithleyMultimeters::dev_state(): entering... !" << endl;

	//	Add your own code to control device here
  if( m_property_missing )
  {
    argout  = Tango::FAULT;
    m_k_status = "A least one property is missing.";
  }
  else if ( !m_kmgr )
  {
    argout  = Tango::FAULT;
    m_k_status = "No communication link built to the device.";
  }
  else
  {
		//- update Manager state/status
		m_kmgr->update_state_status();
		//- now, update device state/status
		argout  = m_kmgr->getState();
		m_k_status = m_kmgr->getStatus();
  }

	set_status(m_k_status);

	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::dev_state
	set_state(argout);    // Give the state to Tango.
	if (argout!=Tango::ALARM)
		DeviceImpl::dev_state();
	return get_state();  // Return it after Tango management.
}
//--------------------------------------------------------
/**
 *	Command ReadBufferedData related method
 *	Description: Command to read back acquired/buffered data
 *
 */
//--------------------------------------------------------
void KeithleyMultimeters::read_buffered_data()
{
	// DEBUG_STREAM << "KeithleyMultimeters::ReadBufferedData()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyMultimeters::read_buffered_data) ENABLED START -----*/
	
	//	Add your own code
	// DEBUG_STREAM << "KeithleyMultimeters::read_buffered_data(): entering... !" << endl;

	//	Add your own code to control device here
	if ( !m_kmgr )
	{
		Tango::Except::throw_exception(
			"INIT_ERROR",
			"Device is not initialised.",
			"KeithleyMultimeters::read_buffered_data()");
	}

	std::size_t size = m_kmgr->get_actual_nbPoints();
	if ( !size )
	{
		Tango::Except::throw_exception ("NO_DATA",
			"Keithley buffer is empty! Start a new acquisition first.",
			"KeithleyManager::readBufferedData");
	}


	//- get Keithley buffered data and parse them
	m_kmgr->readBufferedData();

	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::read_buffered_data
}
//--------------------------------------------------------
/**
 *	Command WriteRead related method
 *	Description: Direct access to send (SCPI) low level commands to the instrument
 *
 *	@param argin Low level command to send
 *	@returns Command response (if any)
 */
//--------------------------------------------------------
Tango::DevString KeithleyMultimeters::write_read(Tango::DevString argin)
{
	Tango::DevString argout;
	// DEBUG_STREAM << "KeithleyMultimeters::WriteRead()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyMultimeters::write_read) ENABLED START -----*/
	
	//	Add your own code
	//	POGO has generated a method core with argout allocation.
	//	If you would like to use a static reference without copying,
	//	See "TANGO Device Server Programmer's Manual"
	//		(chapter : Writing a TANGO DS / Exchanging data)
	//------------------------------------------------------------
	// DEBUG_STREAM << "KeithleyMultimeters::write_read(): entering... !" << endl;

	//	Add your own code to control device here
	if ( !m_kmgr )
	{
		Tango::Except::throw_exception(
			"INIT_ERROR",
			"Device is not initialised.",
			"KeithleyMultimeters::read_buffered_data()");
	}

	std::string response("Unknown");

	response = m_kmgr->write_read(argin);
	
	if( !response.empty() )
	{
		argout  = new char[response.size() + 1];
	}

	::strcpy(argout, response.c_str());

	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::write_read
	return argout;
}
//--------------------------------------------------------
/**
 *	Command Abort related method
 *	Description: Command to stop/abort acquisition
 *
 */
//--------------------------------------------------------
void KeithleyMultimeters::abort()
{
	// DEBUG_STREAM << "KeithleyMultimeters::Abort()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyMultimeters::abort) ENABLED START -----*/
	
	//	Add your own code
	// DEBUG_STREAM << "KeithleyMultimeters::abort(): entering... !" << endl;

	//	Add your own code to control device here
  if ( !m_kmgr )
  {
    Tango::Except::throw_exception(
      "INIT_ERROR",
      "Device is not initialised.",
      "KeithleyMultimeters::abort()");
  }

  m_kmgr->abort_scan();

	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::abort
}
//--------------------------------------------------------
/**
 *	Command Configure related method
 *	Description: Sends the user configuration defined in property.
 *
 */
//--------------------------------------------------------
void KeithleyMultimeters::configure()
{
	// DEBUG_STREAM << "KeithleyMultimeters::Configure()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyMultimeters::configure) ENABLED START -----*/
	
	//	Add your own code
  if ( !m_kmgr )
  {
    Tango::Except::throw_exception(
      "INIT_ERROR",
      "Device is not initialised.",
      "KeithleyMultimeters::configure()");
  }

  m_kmgr->configure_scan();
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::configure
}
//--------------------------------------------------------
/**
 *	Command StartAcquisition related method
 *	Description: Command to start a new acquisition
 *
 */
//--------------------------------------------------------
void KeithleyMultimeters::start_acquisition()
{
	// DEBUG_STREAM << "KeithleyMultimeters::StartAcquisition()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(KeithleyMultimeters::start_acquisition) ENABLED START -----*/
	
	//	Add your own code
  if ( !m_kmgr )
  {
    Tango::Except::throw_exception(
      "INIT_ERROR",
      "Device is not initialised.",
      "KeithleyMultimeters::start_acquisition()");
  }

  m_kmgr->start_scan();
	
	/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::start_acquisition
}

/*----- PROTECTED REGION ID(KeithleyMultimeters::namespace_ending) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::namespace_ending
} //	namespace
